import random
import time
import datetime
import sys
import os
import csv
import popen2
import ConfigParser
from sets import Set as set
PSQLDIR=os.getcwd()+"/"
TMPDIR=os.getcwd()+"/"
SAMPLE=int(sys.argv[1])
POPULATION=int(sys.argv[2])
DBNAME=sys.argv[3]
TABLENAME=sys.argv[4]
ATT1=sys.argv[5]
ATT2=sys.argv[6]
ERRORSLOGFILE=os.getcwd()+"/.randomtest_errors"
def logerrors(ferr):
  errfile=open(ERRORSLOGFILE,"a")
  errfile.write(ferr.read())
  errfile.close()

def createTable(db, sampleSize, population, tablename,att1,att2):
    rand=[]
    rand.append(set([]))
    while len(rand[0])<sampleSize:
        rand[0].add((int(round(random.random()*population))
          ,int(round(random.random()*population))))
    csvfile=open(TMPDIR + ".randtest"+tablename+".csv", "wb")
    writer = csv.writer(csvfile)
    for row in rand[0]:
        writer.writerow(row)
    csvfile.close()
    fin, fout, ferr = popen2.popen3(PSQLDIR + "psql " + db + 
        " -t -c 'CREATE TABLE " + tablename + "(" +
        att1 +" int, "+ att2 +" int)'")
    logerrors(ferr)
    fin, fout, ferr = popen2.popen3(PSQLDIR + "psql " + db + 
        " -t -c 'TRUNCATE " + tablename + "'")
    logerrors(ferr)
    fin, fout, ferr = popen2.popen3(PSQLDIR + "psql " + db + " -t -c \"COPY "
         + tablename + " FROM " + "'" + TMPDIR + 
         ".randtest"+ tablename + ".csv" + "'" + " CSV\"")
    logerrors(ferr)
    return

#clear errorfile
errfile=open(ERRORSLOGFILE,"w")
errfile.close()
createTable(DBNAME, SAMPLE, POPULATION, TABLENAME,ATT1,ATT2)
